<?php


// Add the new filter
add_filter('upload_mimes', 'addUploadMimes');

/**
 * Adds new supported media types for upload.
 */
function addUploadMimes($mimes)
{
	$mimes = array_merge($mimes, array(
		'kml' => 'application/octet-stream',
		'gpx' => 'application/octet-stream'
	));

	return $mimes;
}


if ( is_admin() ){

	add_action('admin_menu', 'geomap_admin_menu');

	function geomap_admin_menu() {
		add_options_page(
			'WP Geoportail ShortCode',
			'WP Geoportail ShortCode',
			'administrator',
			'WP-Geoportail-ShortCode',
			'WP_Geoportail_ShortCode_html_page'
		);
	} //function
}//if

function WP_Geoportail_ShortCode_html_page() {

// See if the user has posted us some information
// If they did, this hidden field will be set to 'Y'

if( isset($_POST['submit_hidden']) && $_POST['submit_hidden'] == 'Y' ) {
    // Read/Save Values 
    $temp = $_POST['geomap_lat'];
    update_option('geomap_lat', $temp );
    
    $temp = $_POST['geomap_lon'];
    update_option('geomap_lon', $temp );
    
    $temp = $_POST['geomap_type'];
    update_option('geomap_type', $temp );
   
    $temp = $_POST['geomap_territory'];
    update_option('geomap_territory', $temp );

 
    $temp = $_POST['geomap_z'];
    update_option('geomap_z', $temp );
    
    $temp = $_POST['geomap_w'];
    update_option('geomap_w', $temp );
    
    $temp = $_POST['geomap_h'];
    update_option('geomap_h', $temp );
    
    $temp = $_POST['geomap_key'];
    update_option('geomap_key', $temp );

    $temp = $_POST['geomap_layers'];
    update_option('geomap_layers', $temp);
    
    $temp = $_POST['geomap_layers_array'];
    update_option('geomap_layers_array', $temp);

    $temp = $_POST['geomap_apiVersion'];
    update_option('geomap_apiVersion', $temp );
    // Put an settings updated message on the screen
	?>
	<div class="updated"><p><strong><?php _e('settings saved.', 'menu-test' ); ?></strong></p></div>
	<?php
}

?>

<div>
	<h2>WP Geoportail ShortCode Settings</h2>
		<p>You can adjust here the default parameters:</p>
		<form id="myForm" method="post" onsubmit="return OnSubmitForm();">
		<input type="hidden" name="submit_hidden" value="Y" />

		<div>
		<center>
			<table width="100%">
				<tr valign="top" align="left" >
					<th width="200" scope="row">Your API Key :</th>
					<td>
						<input name="geomap_key" id="geomap_key"
							 type="text"
							 id="geomap_key"
							 value="<?php echo get_option('geomap_key'); ?>"
							 style="width:200px;" />
					</td>
				</tr>
				<tr valign="top" align="left" >
					<th width="200" scope="row">API Version :</th>
					<td>
						<select name="geomap_apiVersion" id="geomap_apiVersion" style="width:50px;" />
							<option value="1.1" <?php echo(get_option('geomap_apiVersion')=='1.1'?'selected':'') ?> > 
		                                                1.1
		                                        </option>
		                                        <option value="1.2" <?php echo(get_option('geomap_apiVersion')=='1.2'?'selected':'') ?> >
		                                                1.2
		                                        </option>
		                                        <option value="1.3" <?php echo(get_option('geomap_apiVersion')=='1.3'?'selected':'') ?> >
		                                                1.3 (default)
		                                        </option>
						</select>
					</td>
				</tr>
                                <tr valign="top" align="left" >
                                        <th width="200" scope="row">Territory :</th>
                                        <td>
                                                <select name="geomap_territory" id="geomap_territory" style="width:200px;" />
                                                        <option value="FFX" <?php echo(get_option('geomap_territory')=='FFX'?'selected':'') ?> >
                                                                France métropolitaine
                                                        </option>
                                                        <option value="GLP" <?php echo(get_option('geomap_territory')=='GLP'?'selected':'') ?> >
                                                                Guadeloupe
                                                        </option>
							<option value="GUF" <?php echo(get_option('geomap_territory')=='GUF'?'selected':'') ?> >
                                                                Guyane
                                                        </option>
							<option value="MTQ" <?php echo(get_option('geomap_territory')=='MTQ'?'selected':'') ?> >
                                                                Martinique
                                                        </option>
							<option value="MYT" <?php echo(get_option('geomap_territory')=='MYT'?'selected':'') ?> >
                                                                Mayotte
                                                        </option>
							<option value="NCL" <?php echo(get_option('geomap_territory')=='NCL'?'selected':'') ?> >
                                                                Nouvelle Calédonie
                                                        </option>
                                                        <option value="PYF" <?php echo(get_option('geomap_territory')=='PYF'?'selected':'') ?> >
                                                                Polynésie Française
                                                        </option>
                                                        <option value="REU" <?php echo(get_option('geomap_territory')=='REU'?'selected':'') ?> >
                                                                Réunion
                                                        </option>
                                                        <option value="SPM" <?php echo(get_option('geomap_territory')=='SPM'?'selected':'') ?> >
                                                                Saint Pierre et Miquelon
                                                        </option>
                                                        <option value="WLF" <?php echo(get_option('geomap_territory')=='WLF'?'selected':'') ?> >
                                                                Wallis et Futuna
                                                        </option>
                                                </select>
                                        </td>
                                </tr>
				<tr valign="top" align="left" >
					<th width="200" scope="row">Lat:</th>
					<td>
						<input name="geomap_lat"
							 type="text"
							 id="geomap_lat"
							 value="<?php echo get_option('geomap_lat'); ?>"
							 style="width:50px;" />
					</td>
				</tr>
				<tr valign="top" align="left" >
					<th width="200" scope="row">Lon:</th>
					<td>
						<input name="geomap_lon"
							 type="text"
							 id="geomap_lon"
							 value="<?php echo get_option('geomap_lon'); ?>"
							 style="width:50px;" />
					</td>
				</tr>
				<tr valign="top" align="left" >
					<th width="200" scope="row">Zoom Level:</th>
					<td>
						<input name="geomap_z"
							 type="text"
							 id="geomap_z"
							 value="<?php echo get_option('geomap_z'); ?>"
							 style="width:50px;" />
					</td>
				</tr>
				<tr valign="top" align="left" >
					<th width="50" scope="row">Map Width:</th>
					<td>
						<input name="geomap_w"
							 type="text"
							 id="geomap_w"
							 value="<?php echo get_option('geomap_w'); ?>"
							 style="width:50px;" />
					</td>
				</tr>
				<tr valign="top" align="left" >
					<th width="200" scope="row">Map Height:</th>
					<td>
						<input name="geomap_h"
							 type="text"
							 id="geomap_h"
							 value="<?php echo get_option('geomap_h'); ?>"
							 style="width:50px;" />
					</td>
				</tr>
				<tr valign="top" align="left" >
					<th width="200" scope="row">Viewer Type:</th>
					<td>
						<?php 
							$t = get_option('geomap_type');
							if (!($t))
								$t = 'normal';
						?>
						<input type="radio"
							name="geomap_type"
							value="normal" <?php if ($t == 'normal') echo 'checked'; ?> >
							<b>Normal</b> : this viewer type displays a full viewer, with all the tools.
						<br />
						<input type="radio"
							name="geomap_type"
							value="mini" <?php if ($t == 'mini') echo 'checked'; ?>>
							<b>Mini</b> : this viewer type displays a min viewer, without tools.
						<br />
					</td>
				</tr>
				<tr valign="top" align="left" >
					<th width="200" scope="row">Layers settings:</th>
					<td>
						<div id="no_api_key" > <b> Please Enter a valide API key first, in order to obtain allowed layers. </b> </div>
						<div id="layer_simple"  style="display:none">
							<b> Simple Mode </b>: Click <a href="javascript:switchMode();"> here</a> to see all allowed layers.
								<table class="simpleTable" id="simpleTable">
								<thead>
									<tr>
										<th>Display</th>
										<th>Layer Name</th>
										<th>Visibility</th>
										<th>Opacity</th>
									</tr>
								</thead>
								<tbody>
								</tbody>
							</table>
						</div>
						<div id="layer_avanced" style="display:none">
							<b> Avanced Mode </b>: all allowed layers in your api contrat! <br/>
							Click <a href="javascript:switchMode();"> here</a> to see simple mode.
							A description of each layer is available<a href="https://api.ign.fr/geoportail/api/doc/fr/webmaster/layers.html" target="_blank"> here</a>.
								<table class="avancedTable" id="avancedTable">
								<thead>
									<tr>
										<th>Display</th>
										<th>Layer Name</th>
										<th>Visibility</th>
										<th>Opacity</th>
									</tr>
								</thead>
								<tbody>
								</tbody>
							</table>
						</div>
					</td>
				</tr>
			</table>
		</center>
		</div>

<?php
if (get_option('geomap_key') != '' )
{
?>
	<script type="text/javascript" src="http://api.ign.fr/geoportail/api?key=<?php echo get_option('geomap_key'); ?>&includeEngine=false&">
			<!--//--><![CDATA[//><!-- //--><!]]>
	</script>

	<script language="javascript">
		var layers_allowed = null;
		var nb_simple_layers = 0;
		var orthoName="Ortho Images";
		var mapName="IGN Maps";
		
		var layers_activate =  new Array();
<?php
		if (get_option('geomap_key') != '' )
		{
?>
			temp = "<?php echo get_option('geomap_layers_array') ?>";
			temp = temp.split(/;/);
			temp.pop(); // supprime la derniere case vide
			
			for (i=0; i<temp.length; i++)
			{
				temp_1=temp[i].split('|');
				layers_activate.push( temp_1[0] );
				layers_activate[ temp_1[0] ] =  new Array();
				layers_activate[ temp_1[0] ].push( temp_1[1]);
				layers_activate[ temp_1[0] ].push( temp_1[2]);
			}

<?php
		}
?>
		
		window.onload= function(){
			layers_allowed = gGEOPORTALRIGHTSMANAGEMENT['<?php echo get_option('geomap_key'); ?>'].allowedGeoportalLayers;
			var avancedTable = document.getElementById("avancedTable");
			var simpleTable = document.getElementById("simpleTable");
			for(i=0;i<layers_allowed.length;++i)
			{
				addLigne(layers_allowed[i],i,avancedTable);
				
				if(layers_allowed[i] == "GEOGRAPHICALGRIDSYSTEMS.MAPS:WMSC")
				{
					addLigne(mapName,"s_"+nb_simple_layers,simpleTable);
					nb_simple_layers++;
				}
					
				if(layers_allowed[i] == "ORTHOIMAGERY.ORTHOPHOTOS:WMSC")
				{
					addLigne(orthoName,"s_"+nb_simple_layers,simpleTable);
					nb_simple_layers++;
				}
			}
			if(layers_allowed.length!=0)
			{
				visibilite("no_api_key");
				visibilite("layer_simple");
			}
	}

	/* ajoute une ligne */
	function addLigne(name,num,table)
	{
		
		var nameTemp = name;
		var isActivate = true;
		
		if(name == mapName)
			nameTemp = "GEOGRAPHICALGRIDSYSTEMS.MAPS:WMSC";
		if(name == orthoName)
			nameTemp = "ORTHOIMAGERY.ORTHOPHOTOS:WMSC";
		
		if( typeof(layers_activate[nameTemp]) == 'undefined')
			isActivate = false;
		
		var tbody = table.tBodies[0];
		
		var row = document.createElement("tr");
		
			var cell_1 = document.createElement("td");
				var input_1 = document.createElement("input");
				input_1.setAttribute("type","checkbox");
				input_1.setAttribute("id","layer_display_"+num);
				//input_1.setAttribute("name","layer_display_"+name);
				
			if (isActivate)
				input_1.setAttribute("checked",true);
			
			cell_1.appendChild(input_1);
			row.appendChild(cell_1);
			
			var cell_2 = document.createElement("td");
				var input_2 = document.createElement("input");
				input_2.setAttribute("type","text");
				input_2.setAttribute("disabled","disabled");
				input_2.setAttribute("style","width:300px;");
				input_2.setAttribute("id","layer_name_"+num);
				input_2.value=name;
			cell_2.appendChild(input_2);
			row.appendChild(cell_2);
			
			var cell_3 = document.createElement("td");
				var input_3 = document.createElement("input");
				input_3.setAttribute("type","checkbox");
				input_3.setAttribute("id","layer_visibility_"+num);
				//input_3.setAttribute("name","layer_visibility_"+name);
				
				if(isActivate)
				{
					if(layers_activate[nameTemp][0] == 'on')
					{
						input_3.setAttribute("checked",true);
					}
				}
					
			cell_3.appendChild(input_3);
			row.appendChild(cell_3);
			
			var cell_4 = document.createElement("td");
				var input_4 = document.createElement("input");
				input_4.setAttribute("type","number");
				input_4.setAttribute("min","0");
				input_4.setAttribute("max","1");
				input_4.setAttribute("step","0.1");
				input_4.setAttribute("style","width:50px;");
				input_4.setAttribute("id","layer_opacity_"+num);
				//input_4.setAttribute("name","layer_opacity_"+name);
				if(isActivate)
					input_4.value=layers_activate[nameTemp][1];
				else
					input_4.value=1;
			cell_4.appendChild(input_4);
			row.appendChild(cell_4);
			
		tbody.appendChild(row);
	}
	</script>

	<?php	
} 
	?>

		<input type="hidden" name="geomap_layers_array" id="geomap_layers_array" value="" />
		<p>
			<input type="submit" value="<?php _e('Save Changes') ?>" />
		</p>

	</form>
</div>

<script language="javascript">
	var mode="simple";
	function visibilite(thingId)
	{
		var targetElement;
		targetElement = document.getElementById(thingId) ;
		if (targetElement.style.display == "none")
		{
			targetElement.style.display = "" ;
		} else {
			targetElement.style.display = "none" ;
		}
	}
	function switchMode()
	{
		visibilite('layer_simple');
		visibilite('layer_avanced');
		
		if (mode == "simple")
			mode="avanced";
		else
			mode="simple";
	}
	function OnSubmitForm()
	{
		var input_layers = document.getElementById("geomap_layers_array");
		
		if(mode == "avanced")
		{
			for(i=0;i<layers_allowed.length;++i)
			{
				if(document.getElementById("layer_display_"+i).checked==true)
				{
				
					input_layers.value += document.getElementById("layer_name_"+i).value +"|";
					
					if(document.getElementById("layer_visibility_"+i).checked==true)
						input_layers.value +="on|"
					else
						input_layers.value +="off|"
					
					input_layers.value += document.getElementById("layer_opacity_"+i).value +";";
				}
			}
		}
		else
		{
			for(i=0;i<nb_simple_layers;++i)
			{
				if(document.getElementById("layer_display_s_"+i).checked==true)
				{
					if( document.getElementById("layer_name_s_"+i).value == orthoName)
						input_layers.value += "ORTHOIMAGERY.ORTHOPHOTOS:WMSC" +"|";
					
					if( document.getElementById("layer_name_s_"+i).value == mapName)
						input_layers.value += "GEOGRAPHICALGRIDSYSTEMS.MAPS:WMSC" +"|";
					
					if(document.getElementById("layer_visibility_s_"+i).checked==true)
						input_layers.value +="on|"
					else
						input_layers.value +="off|"
					
					input_layers.value +=   document.getElementById("layer_opacity_s_"+i).value +";";
				}
			}	
		}
	}
</script>

<?php 
	//foreach($_POST as $key => $val) echo '$_POST["'.$key.'"]='.$val.'<br />';
?>
	
<?php

}

?>

